--
-- test Working Script
--
-- by Zippo
-- 


test = {}

function test.prerequisitesPresent(specializations)
	Vehicle.registerJointType("frontloader");
    return SpecializationUtil.hasSpecialization(Steerable, specializations);
end;

function test:load(xmlFile)	

	local translationLopataNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationLopata#index"));
        if translationLopataNode ~= nil then
        self.translationLopata = {};
        self.translationLopata.node = translationLopataNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationLopata#minTrans"));
        self.translationLopata.minTrans = {};
        self.translationLopata.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationLopata.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationLopata.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationLopata#maxTrans"));
        self.translationLopata.maxTrans = {};
        self.translationLopata.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationLopata.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationLopata.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationLopata.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationLopata#transTime"), 2)*1000;
        self.translationLopata.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationLopata#touchTransLimit"), 10);
    end;
      
function test:delete()
end;

function test:mouseEvent(posX, posY, isDown, isUp, button)
end;
	  
function test:keyEvent(unicode, sym, modifier, isDown)

	if sym == Input.KEY_7 then
		self.translationLopataMax = isDown;
	end;
	if sym == Input.KEY_8 then
		self.translationLopataMin = isDown;
	end;
end;

function test:update(dt)
	
	local doTranslate = self.translationLopataMax or self.translationLopataMin 
	if self.translationLopata ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationLopata.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationLopata.maxTrans, self.translationLopata.minTrans, 3, self.translationLopata.transTime, dt, not self.translationLopataMax); 
		setTranslation(self.translationLopata.node, unpack(newTrans)); 
	end;
    else
        if self.hydra2Playing then
            stopSample(self.hydra2SoundId);
            self.hydra2Playing = false;
        end;
    end;

end;

function test:draw()
end;

function test:validateAttacherJoint(implement, jointDesc, dt)
    return true;
end;
